﻿define("aiassistant/editors/AiPromptDialog", [
    "dijit/Dialog",
    "dojo/_base/declare",
    "dijit/_TemplatedMixin",
    "dijit/_CssStateMixin",
    "dijit/form/_FormMixin",
    "dijit/_DialogMixin",
], function (Dialog, declare, TemplatedMixin, CssStateMixin, FormMixin, DialogMixin) {
    // Extend the Dialog widget
    return declare([Dialog, TemplatedMixin, FormMixin, DialogMixin, CssStateMixin], {
        pluginpath: "", //custom prop
        pluginversion: "", //custom prop
        pluginmodulepath: "", //custom prop
        correlationid: "", //custom prop
        initialSelection: "", //custom prop
        propname: "", //custom prop
        lang: "", //custom prop
        contentid: "", //custom prop
        isHtml: false, //custom prop
        selection: null, //custom prop
        ui: null, //custom prop
        defaultText: "", //send in command and execute
        _useContent: function () {
            //console.log("Dialog clicked", this.selection);
            if (this.selection) {

                if (!this.isHtml) {
                   this.selection.text = this.formatHtmlToText(this.selection.text);
                }

                var data = { "action": "use", "data": this.selection };
                window.postMessage(data, location.origin);
            }
        },
        markButton: function (data) {
            this.selection = data;
            //console.log("Dialog selected", this.selection);
            this.actionButtonNode.disabled = false;
            this.actionButtonNode.parentNode.classList.remove("dijitButtonDisabled");
            this.actionButtonNode.innerHTML = data.useButton;
        },
        unmarkButton: function () {
            this.selection = null;
            this.actionButtonNode.disabled = true;
            this.actionButtonNode.parentNode.classList.add("dijitButtonDisabled");
        },
        formatHtmlToText: function(text) {
            // Check if the text contains HTML tags
            if(/<\/?[a-z][\s\S]*>/i.test(text)) {
                text = text.replace(/<br>/g, '\n');
                text = text.replace(/<[^>]*>/g, '');

                console.log("Replace html to text", text)
            }

            return text;
        },
        _size: function () {
            this.inherited(arguments);
            this.containerNode.style.height = "528px";
            this.actionButtonNode.disabled = true;
        }

    });
});